#!/bin/sh
# Start FileflexEneterprice VM image at device startup


. /etc/script/lib/command.sh

APKG_PKG_DIR=/volume1/.@plugins/AppCentral/FileFlexEnterpriseServer
QN_VBOXMANAGE="/volume1/.@plugins/AppCentral/virtualbox/bin/VBoxManage"
QN_VM_ID_FILE="${APKG_PKG_DIR}/www/vmid.txt"
QN_VM_STATE_FILE="${APKG_PKG_DIR}/www/boot_state.txt"
QN_VM_STATE=`cat ${APKG_PKG_DIR}/www/boot_state.txt`
QN_VM_ID=`cat ${QN_VM_ID_FILE}`
QN_DATE="date \"+%Y%m%d-%H%M%S\""
# Get Id
if [ -z "$QN_VM_ID" ]; then
    echo "No Vm id"
fi

export "LD_LIBRARY_PATH=/volume1/.@plugins/AppCentral/virtualbox/bin"
export "PATH=$PATH:/volume1/.@plugins/AppCentral/virtualbox/bin"
# check for installed machine.

case $1 in

	start)
		# echo "$QN_DATE Executing start" >>$APKG_PKG_DIR/log.txt
		# echo "$QN_DATE Qn state is  $QN_VM_STATE" >>$APKG_PKG_DIR/log.txt
		# echo "$QN_DATE ID of machine is $QN_VM_ID" >>$APKG_PKG_DIR/log.txt
        if [ "$QN_VM_STATE" == "start" ]; then
		# echo "$QN_DATE Executing start" >>$APKG_PKG_DIR/log.txt
		# Start VM
		# while ! ps aux | grep -v grep | grep "vboxwebsrv"; do
			#echo "$QN_DATE Executing start" >>$APKG_PKG_DIR/log.txt
			#sleep 1
		# done
        ${QN_VBOXMANAGE} startvm $QN_VM_ID --type headless >>$APKG_PKG_DIR/log.txt 2>&1
		fi
		;;

	stop)
		# if VM is running and save state.
		if ${QN_VBOXMANAGE} list runningvms | grep -w ${QN_VM_ID} > /dev/null; then
			echo "start" > ${APKG_PKG_DIR}/www/boot_state.txt
		else
			echo "stop" > ${APKG_PKG_DIR}/www/boot_state.txt
		fi

		# stop VM
        ${QN_VBOXMANAGE} controlvm $QN_VM_ID savestate >>$APKG_PKG_DIR/log.txt 2>&1
		;;

	*)
		echo "usage: $0 {start|stop}"
		exit 1
		;;
esac
exit 0