<?php

session_start();

    if (!empty($_SESSION["deploymentId"])) {

        $page = "download-and-install";

        $action = "standby";
        if (isset($_GET["action"])) $action = $_GET["action"];

        include "include/strings.php";
        include "include/functions.php";
        include "include/head.php";
        include "include/body.php";

        // START: Adding the unique content for the page -->

        echo "<button type='button' id='buttonDownload' class='spaceRight' ";
        if ($action == "install" || $action == "complete") echo "disabled";
        echo ">$buttonDownload</button>";

        if ($action == "downloaded") {
            echo "<script>var vmid = 0;</script>";
        }
        if ($action == "standby" || $action == "downloaded") {
            echo "<span style='display: none;' id='messageDownloading'>$messageDownloading</span>";
            echo "<div class='progressBorder'>";
            echo "<div id='progressNumber' class='progressNumber'>0%</div>";
            echo "<div id='progressContent' class='progressContent' style='width: 0%'></div>";
            echo "</div>";
        }
        if ($action == "install") {
            echo "<span id='messageInstalling'>$messageInstalling</span>";
            echo "<div class='progressBorder'>";
            echo "<div id='progressContentInfinite' class='progressContentInfinite'></div>";
            echo "<div id='progressInstallingMessage' class='progressNumber'>$messageInstallingProgress</div>";
            echo "</div>";
        }
        if ($action == "complete") {

            $vmid = $_GET['vmid'];
            echo"<script>var vmid = '".$vmid."';</script>";

            echo "<span class='messageInstallationComplete'>$messageInstallationComplete</span>";
            echo "<div class='progressBorder'>";
            echo "<div id='progressNumber' class='progressNumber'>100%</div>";
            echo "<div id='progressContent' class='progressContent' style='width: 100%'></div>";
            echo "</div>";
        }


        echo "<br/><br/>";
        echo"<a class='button left' href='".$helpUrl."' target='_blank'>$buttonHelp</a>";
        echo "<button id='buttonNext' class='right spaceLeft' type='button' ";
        if ($action == "standby" || $action == "download" || $action == "install") echo "disabled";
        echo ">$buttonNext</button>";


        // Start installing
        if ($action == "install") {

            echo "<br/><br/>";

            ob_end_flush();
            ob_flush();
            flush();

            // rename temp file after download finishes
            if (file_exists("downloads/".$filename.".tmp")) rename("downloads/".$filename.".tmp", "downloads/".$filename.".ova");

            $command = "./qnwrapper import ".$pathOva;
            exec($command, $output, $return_var);

            if ($return_var == 1) {
                // Error
                showError($messageInstallingError);
                addLog("ERROR", "Installation", $_SESSION["deploymentId"], NULL, $_SESSION["deploymentUrl"], NULL, $output);
            } else {

                // Success -> List the last installed machine and get the vmid
                $commandlist = "./qnwrapper list vms";
                $outputlist = exec($commandlist);

                preg_match_all('/{(.*?)}/', $outputlist, $matches);
                $vmid = end($matches[1]);

                preg_match_all('/"(.*?)"/', $outputlist, $matches);
                $vmname = current($matches[1]);

                // enable the remote desktop on VM
                exec("./qnwrapper modifyvm \"".$vmname."\" --vrde on", $output_rdp, $return_var_rdp);


                // Save vmid in a file
                $myfile = file_put_contents($vmidfile, $vmid, FILE_APPEND | LOCK_EX);


                if ($return_var_rdp == 1) {
                    // Error enabling the remote desktop on the VM
                    showError($messageEnablingRdpError);
                    addLog("ERROR", "Enabling RDP", $_SESSION["deploymentId"], NULL, $_SESSION["deploymentUrl"], NULL, $output_rdp);
                } else {
                    addLog("SUCCESS", "Installation", $_SESSION["deploymentId"], NULL, $_SESSION["deploymentUrl"], NULL, $output);
                    echo "<script>window.open('?action=complete&vmid=".$vmid."', '_self');</script> ";
                }

            }

        }

    // END: Adding the unique content for the page -->

    include "include/footer.php";

    } else {

        // redirect to adding a deployment validation page
        echo "<script>window.open('adding-a-deployment.php', '_self');</script> ";

    }


?>