<?php

session_start();

if (!empty($_SESSION["deploymentId"])) {

    //Set max execution time for the script
    // 7200 seconds = 2 hours
    ini_set('max_execution_time', 7200);
    set_time_limit(0);

    //$fullsize = 1503238553;

    ignore_user_abort(true);
    ob_start();
    // do initial processing here

    $page = "download"; // This must be set because string.php needs page variable. Otherwise it may output warning or notice (before the echo below) which will prevent ajax request to run

    include "include/strings.php";
    include "include/functions.php";


    // Delete the temp file (if there is previously unsuccessful/unfinished download)
    if (file_exists($path)) unlink($path);
    // Delete the ova file (if we want to download a new intallation)
    if (file_exists($pathOva)) unlink($pathOva);


    // Count installation file size
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_USERPWD, $downloadUser.":".$downloadPass);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_NOBODY, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HEADER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); //not necessary unless the file redirects (like the PHP example we're using here)
    $data = curl_exec($ch);
    curl_close($ch);
    if ($data === false) {
        echo 'cURL failed';
        addLog("ERROR", "cURL failed", $_SESSION["deploymentId"], NULL, $_SESSION["deploymentUrl"], NULL, NULL);
        exit;
    }

    $fullsize = 'unknown';
    $status = 'unknown';
    if (preg_match('/^HTTP\/1\.[01] (\d\d\d)/', $data, $matches)) {
        $status = (int)$matches[1];
    }
    if (preg_match('/Content-Length: (\d+)/', $data, $matches)) {
        $fullsize = (int)$matches[1];
    }

    echo"{ \"fullsize\" : ".$fullsize." }"; // send the response
    header("Content-Encoding: none");
    header('Connection: close');
    header('Content-Length: '.ob_get_length());
    ob_end_flush();
    ob_flush();
    flush();

    // Finish counting installation file size


    // Start downloading

    addLog("INFO", "Download Start", $_SESSION["deploymentId"], NULL, $_SESSION["deploymentUrl"], NULL, NULL);

    $fp = fopen($path, 'w');
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_USERPWD, $downloadUser.":".$downloadPass);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_TIMEOUT, 7200);
    curl_setopt($ch, CURLOPT_FILE, $fp);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_exec($ch);
    curl_close($ch);
    fclose($fp);

    addLog("INFO", "Download Finish", $_SESSION["deploymentId"], NULL, $_SESSION["deploymentUrl"], NULL, NULL);

} else {

    // redirect to adding a deployment validation page
    echo "<script>window.open('adding-a-deployment.php', '_self');</script> ";

}

?>