<?php

// Check if there is already installed VM
function isInstalled() {
    global $vmidfile;

    if (file_exists($vmidfile)) {

        $vmid = file_get_contents($vmidfile);

        // Get list of all installed VMs
        $commandlistvm = "./qnwrapper list vms";
        $outputlistvm = shell_exec($commandlistvm);

        if (strpos($outputlistvm, '{'.$vmid.'}') !== false) {
            return $vmid;
        } else {
            return false;
        }

    }
}

// Get stage
function getStage() {

    global $filename;
    global $vmidfile;

    $nextStage = 0;

    // Check if there is already downloaded ova file
    if (file_exists("downloads/".$filename.".ova")) {
        $nextStage=1;
    }

    // Check if there is already installed VM - if true go to next stage, if false - delete txt where we store VM id.
    $vmid = isInstalled();
    if ($vmid != false) {
        $nextStage=2;
    } else {
        // Delete vmid txt file
        unlink($vmidfile);
    }

    return $nextStage;
}

// Logs
function addLog($logType, $logAction, $logDepId, $logDepKey = NULL, $logDepUrl = NULL, $logVmid = NULL, $logOutput = NULL) {

    if (empty($logVmid)) $logVmid = "Not Installed";
    if (empty($logDepUrl)) $logDepUrl = "Not Returned";
    if (empty($logOutput)) $logOutput = "";

    if (is_array($logOutput)) $logOutput = implode(" ", $logOutput);

    $logDepKeyMd5 = md5($logDepKey);

    switch ($logAction) {
        case "Validation":
            $log  = date("F j, Y, g:i a")." | ".$logType." -> ".$logAction." -> dplId: ".$logDepId.", dplKey(md5): ".$logDepKeyMd5.", dplUrl: ".$logDepUrl." | VMID: ".$logVmid." | IP: ".$_SERVER['REMOTE_ADDR'].PHP_EOL."Status: ".$logOutput.PHP_EOL.PHP_EOL;
            break;
        case "Download Start":
        case "Download Finish":
        case "cURL failed":
            $log  = date("F j, Y, g:i a")." | ".$logType." -> ".$logAction." -> dplId: ".$logDepId.", dplUrl: ".$logDepUrl." | IP: ".$_SERVER['REMOTE_ADDR'].PHP_EOL.PHP_EOL;
            break;
        case "Installation":
        case "Enabling RDP":
            $log  = date("F j, Y, g:i a")." | ".$logType." -> ".$logAction." -> dplId: ".$logDepId.", dplUrl: ".$logDepUrl." | IP: ".$_SERVER['REMOTE_ADDR'].PHP_EOL."Status: ".$logOutput.PHP_EOL.PHP_EOL;
            break;
        case "Start VM":
        case "Stop VM":
            $log  = date("F j, Y, g:i a")." | ".$logType." -> ".$logAction." -> dplId: ".$logDepId.", dplKey(md5): ".$logDepKeyMd5.", dplUrl: ".$logDepUrl." | VMID: ".$logVmid." | IP: ".$_SERVER['REMOTE_ADDR'].PHP_EOL."Status: ".$logOutput.PHP_EOL.PHP_EOL;
            break;
    }

    file_put_contents('./logs/logs.txt', $log, FILE_APPEND);

}

// Show error
function showError($message)
{
    echo "<script>document.getElementById('messageInstalling').innerHTML = '$message'</script>";
    echo "<script>document.getElementById('messageInstalling').style.color='red'</script>";
    echo "<script>document.getElementById('progressInstallingMessage').innerHTML = '$message'</script>";
    echo "<script>document.getElementById('progressContentInfinite').classList.remove('progressContentInfinite');</script>";
}


function warning_handler($errno, $errstr) {
}

// Get status for deployment id and key
function getStatus($did, $dkey, $error) {

    set_error_handler("warning_handler", E_WARNING);

    $context = stream_context_create(array(
        'http' => array(
            'method'=>"GET",
            'header'=>"Authorization: Bearer ".$dkey."\r\n"
        )
    ));

    $status = urlencode('{"a":true,"c":2}');
    $info = urlencode('{"i":"'.$did.'","n":"Dummy","u":"http://dummy.com"}');
    $url = 'https://portal.fileflex.com/portal/api/protected/ajax/msp_get_status?idMsp='.$did.'&status='.$status.'&info='.$info;

    $file = file_get_contents($url, false, $context);

    if ($error == true) {
        $contents = file_get_contents($url, false, stream_context_create(array(
            'http' => array(
                'ignore_errors' => true
            )
        )));
        return $contents;
    } else {
        return $file;
    }





}

?>